data = [(37, 87), (42, 96), (50, 91), (51, 80), (52, 39), (87, 75), (76, 84), (94, 30), (108, 52), (145, 74)]

for bits, target in data:
    import peqnp as cnf

    cnf.engine(bits)

    x = cnf.integer(key='x')
    y = cnf.integer(key='y')
    z = cnf.integer(key='z')

    assert cnf.one_of([x ** 3 + y ** 3 - z ** 3, x ** 3 - y ** 3 - z ** 3]) == target

    if cnf.satisfy(turbo=True, log=True, cnf_path='sum_of_3_cubes_{}_bits_{}.cnf'.format(bits, target), solve=False):
        print(x, y, z)
